# History comparison of deleted parameters with null values

### Overview

Deleted parameters that contained `null` values are not displayed in historical comparisons. Additionally, they do not display `Created At` or `Modified At` Times.

A parameter named `empty.empty` contained a `null` value that was deleted . Since the parameter contained a null value `empty.empty` is not displayed in a projects historical differences table.

```
cloudtruth --project Demo parameters differences --as-of 2021-08-26
+-------------------+---------+----------------------+
| Parameter         | Current | 2021-08-26T00:00:00Z |
+-------------------+---------+----------------------+
| empty             | -       |                      |
| empty.empty_empty | -       |                      |
| lower             | -       | case                 |
| nil               | -       |                      |
| pill              | red     | -                    |
+-------------------+---------+----------------------+
```

The parameter `empty.empty` displays empty times when searching a project on a previous date.

```
cloudtruth --project Demo parameters ls -v --as-of 2021-08-26 --show-times
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+-----------------------------+-----------------------------+
| Name                 | Value                                                                                       | Source  | Type     | Secret | Description | Created At                  | Modified At                 |
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+-----------------------------+-----------------------------+
| CHARACTER            | NEO                                                                                         | default | internal | false  |             | 2021-08-25T14:18:59.117018Z | 2021-08-25T14:18:59.117023Z |
| TF_VAR_resource_tags | {"Name":"Cloudtruth-Instance","project":"CloudTruth Run Terraform","environment":"default"} | default | internal | false  |             | 2021-08-25T14:18:59.129339Z | 2021-08-25T14:18:59.129344Z |
| empty                |                                                                                             | default | internal | false  |             | 2021-08-25T14:18:59.119914Z | 2021-08-25T14:18:59.119919Z |
| empty.empty          | -                                                                                           |         | internal | false  |             |                             |                             |
| empty.empty_empty    |                                                                                             | default | internal | false  |             | 2021-08-25T14:18:59.120008Z | 2021-08-25T14:18:59.120013Z |
| lower                | case                                                                                        | default | internal | false  |             | 2021-08-25T14:18:59.122449Z | 2021-08-25T14:18:59.122454Z |
| nil                  |                                                                                             | default | internal | false  |             | 2021-08-25T14:18:59.122730Z | 2021-08-25T14:18:59.122735Z |
| node.name            | "${NODE_NAME}"                                                                              | default | internal | false  |             | 2021-08-25T14:18:59.122762Z | 2021-08-25T14:18:59.122766Z |
| secret               | *****                                                                                       | default | internal | true   |             | 2021-08-25T14:18:59.123741Z | 2021-08-25T14:18:59.123746Z |
| service.app.cpu      | 4                                                                                           | default | internal | false  |             | 2021-08-25T14:18:59.126921Z | 2021-08-25T14:18:59.126925Z |
| service.app.memory   | 8                                                                                           | default | internal | false  |             | 2021-08-25T14:18:59.126952Z | 2021-08-25T14:18:59.126957Z |
| service.demo.timeout | 200                                                                                         | default | internal | false  |             | 2021-08-25T14:18:59.127014Z | 2021-08-25T14:18:59.127019Z |
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+-----------------------------+-----------------------------+
```

### Resolution

You can view a list of values a project contained by directly passing a date to a project and viewing the values and comparing the parameters to a current listing.

**Parameters listed as of 2021-08-26**

```
cloudtruth --project Demo parameters ls -v --as-of 2021-08-26
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+
| Name                 | Value                                                                                       | Source  | Type     | Secret | Description |
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+
| CHARACTER            | NEO                                                                                         | default | internal | false  |             |
| TF_VAR_resource_tags | {"Name":"Cloudtruth-Instance","project":"CloudTruth Run Terraform","environment":"default"} | default | internal | false  |             |
| empty                |                                                                                             | default | internal | false  |             |
| empty.empty          | -                                                                                           |         | internal | false  |             |
| empty.empty_empty    |                                                                                             | default | internal | false  |             |
| lower                | case                                                                                        | default | internal | false  |             |
| nil                  |                                                                                             | default | internal | false  |             |
| node.name            | "${NODE_NAME}"                                                                              | default | internal | false  |             |
| secret               | *****                                                                                       | default | internal | true   |             |
| service.app.cpu      | 4                                                                                           | default | internal | false  |             |
| service.app.memory   | 8                                                                                           | default | internal | false  |             |
| service.demo.timeout | 200                                                                                         | default | internal | false  |             |
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+
```

**Comparing the current parameters**

we can find the parameter `empty.empty` is a deleted and contained a null value.

```
cloudtruth --project Demo parameters ls -v 
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+
| Name                 | Value                                                                                       | Source  | Type     | Secret | Description |
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+
| CHARACTER            | NEO                                                                                         | default | internal | false  |             |
| TF_VAR_resource_tags | {"Name":"Cloudtruth-Instance","project":"CloudTruth Run Terraform","environment":"default"} | default | internal | false  |             |
| node.name            | "${NODE_NAME}"                                                                              | default | internal | false  |             |
| pill                 | red                                                                                         | default | internal | false  |             |
| secret               | *****                                                                                       | default | internal | true   |             |
| service.app.cpu      | 4                                                                                           | default | internal | false  |             |
| service.app.memory   | 8                                                                                           | default | internal | false  |             |
| service.demo.timeout | 200                                                                                         | default | internal | false  |             |
+----------------------+---------------------------------------------------------------------------------------------+---------+----------+--------+-------------+
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cloudtruth.com/reference/knowledge-base/cli/history-comparison-of-deleted-parameters-with-null-values.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
